#include "Hooks_ObScript.h"
#include "ObScript.h"
#include "GameAPI.h"
//#include "GameReferences.h"
#include "skse64_common/SafeWrite.h"
#include "skse64_common/skse_version.h"
#include "GameData.h"
#include "GameObjects.h"
#include "GameReferences.h"
#include "Hooks_Gameplay.h"
#include "GameInput.h"

// currently ForceRSXCrash, could also use ToggleESRAM and several others
static ObScriptCommand * s_hijackedCommand = nullptr;

void Hooks_ObScript_Init()
{
	// instead of hooking the entire classic scripting system, we're just hijacking some unused commands

	for(ObScriptCommand * iter = g_firstConsoleCommand; iter->opcode < kObScript_NumConsoleCommands + kObScript_ConsoleOpBase; ++iter)
	{
		if(!strcmp(iter->longName, "ForceRSXCrash"))
		{
			s_hijackedCommand = iter;
			break;
		}
	}
}

bool GetSKSEVersion_Execute(void * paramInfo, void * scriptData, TESObjectREFR * thisObj, void * containingObj, void * scriptObj, void * locals, double * result, void * opcodeOffsetPtr)
{
	_MESSAGE("GetSKSEVersion_Execute");


	Console_Print("SKSE64 version: %d.%d.%d, release idx %d, runtime %08X",
		SKSE_VERSION_INTEGER, SKSE_VERSION_INTEGER_MINOR, SKSE_VERSION_INTEGER_BETA,
		SKSE_VERSION_RELEASEIDX, RUNTIME_VERSION);


	//TESObjectREFR* pRef = Hooks_Gameplay_GetCrosshairRef();
	//if (pRef) {
	//	TESForm* pBaseForm = pRef->baseForm;
	//}

	//UInt32 activeRefID = kFormType_ActiveMagicEffect;

	PlayerCharacter* pPlayer = *g_thePlayer;

	PlayerControls* pPlayerControls = PlayerControls::GetSingleton();
	DumpClass(pPlayerControls, 60);

	MenuControls* pMenuControls = MenuControls::GetSingleton();
	DumpClass(pMenuControls, 20);

	InputStringHolder* pInputStringHolder = InputStringHolder::GetSingleton();
	DumpClass(pInputStringHolder, 120);

	//tList<ActiveEffect>* pActiveEffects = pPlayer->magicTarget.GetActiveEffects();
	//UInt32 count = pActiveEffects->Count();
	//for (UInt32 n = 0; n < count; n++) {
	//	ActiveEffect* pActiveEffect = pActiveEffects->GetNthItem(n);
	//	if (pActiveEffect) {
	//		DumpClass(pActiveEffect, 30);
	//		float magnitude = pActiveEffect->magnitude;
	//	}
	//}


	void* funcOffset = pPlayer + 0x530;

	//DumpClass(pPlayer, 1000);

	TESForm* lookupForm = LookupFormByID(0x7);

	DataHandler* pDataHandler = DataHandler::GetSingleton();

//	EffectSetting* effect = (EffectSetting*)LookupFormByID(0xEFC60);

	//auto enchants = pDataHandler->enchantments;
	//for (UInt32 idx = 0; idx < enchants.count; idx++) {
	//	EnchantmentItem* pForm = enchants[idx];
	//	//DumpClass(pForm, 200);
	//}

	//auto spells = pDataHandler->spells;
	//for (UInt32 idx = 0; idx < spells.count; idx++) {
	//	SpellItem* pForm = spells[idx];
	//	if (pForm) {

	//		const char* name = pForm->fullName.name.c_str();
	//		UInt32 formType = pForm->GetFormType();

	//		UInt32 offsetFormType = pForm->formID;
	//		//DumpClass(pForm, 200);
	//	}
	//}


	//auto arrSHOU = pDataHandler->arrSHOU;
	//for (UInt32 idx = 0; idx < arrSHOU.count; idx++) {
	//	TESShout* pForm = arrSHOU[idx];
	//	if (pForm) {
	//		UInt32 formType = pForm->GetFormType();
	//		UInt32 offsetFormType = pForm->formID;
	//		DumpClass(pForm, 100);
	//	}
	//}

	return true;
}

void Hooks_ObScript_Commit()
{
	ObScriptCommand cmd = *s_hijackedCommand;

	cmd.longName = "GetSKSEVersion";
	cmd.shortName = "skse";
	cmd.helpText = "";
	cmd.needsParent = 0;
	cmd.numParams = 0;
	cmd.execute = GetSKSEVersion_Execute;
	cmd.flags = 0;

	SafeWriteBuf((uintptr_t)s_hijackedCommand, &cmd, sizeof(cmd));
}
